=== modified file 'www/apps/browser/__init__.py'
--- www/apps/browser/__init__.py	2008-07-17 05:09:09 +0000
+++ www/apps/browser/__init__.py	2008-07-21 04:41:38 +0000
@@ -176,6 +176,7 @@
         ('svnadd',      ['Add',          'Schedule the selected temporary files to be added permanently']),
         ('svndiff',     ['Diff',         'View any changes to the selected file since its last committed state']),
         ('svnrevert',   ['Revert',       'Restore the selected files back to their last committed state']),
+        ('svnupdate',   ['Update',       'Update your files with changes from the permanent repository']),
         ('svncommit',   ['Commit',       'Commit any changes to the permanent repository']),
         ('svnlog',      ['View Log',     'View the log of commits of the selected file']),
         ('svncheckout', ['Re-checkout',  'Re-checkout your default directories'])

=== modified file 'www/media/browser/browser.js'
--- www/media/browser/browser.js	2008-07-17 06:43:18 +0000
+++ www/media/browser/browser.js	2008-07-21 04:41:38 +0000
@@ -66,6 +66,7 @@
     "missing": "missing.png",
     "deleted": "deleted.png",
     "modified": "modified.png",
+    "conflicted": "conflicted.png",
     "revision": "revision.png"
 };
 
@@ -733,14 +734,15 @@
      * files selected. */
     set_action_state(["svnadd", "svnrevert", "svncommit"], numsel >= 1 && current_file.svnstatus);
 
-    /* Diff and log only support one path at the moment, so we must have 0 or 1
-     * versioned files selected. If 0, the directory must be versioned. */
+    /* Diff, log and update only support one path at the moment, so we must
+     * have 0 or 1 versioned files selected. If 0, the directory must be
+     * versioned. */
     single_versioned_path = (
          (
           (numsel == 1 && (svnst = file_listing[selected_files[0]].svnstatus)) ||
           (numsel == 0 && (svnst = current_file.svnstatus))
          ) && svnst != "unversioned");
-    set_action_state("svndiff", single_versioned_path);
+    set_action_state(["svndiff", "svnupdate"], single_versioned_path);
 
     /* Log should be available for revisions as well. */
     set_action_state("svnlog", single_versioned_path, true);
@@ -842,6 +844,9 @@
     case "svndiff":
         window.location = path_join(app_path('diff'), current_path, selected_files[0] || '');
         break;
+    case "svnupdate":
+        action_update(selected_files);
+        break;
     case "svncommit":
         action_commit(selected_files);
         break;

=== modified file 'www/media/browser/listing.js'
--- www/media/browser/listing.js	2008-07-17 06:28:23 +0000
+++ www/media/browser/listing.js	2008-07-21 04:41:38 +0000
@@ -181,6 +181,13 @@
     return false;
 }
 
+function action_update(files)
+{
+    if (files.length == 0) files = ".";
+    do_action("svnupdate", current_path, {"path": files});
+    return false;
+}
+
 function action_commit(files)
 {
     /* Get a commit log from the user */

=== added file 'www/media/images/svn/conflicted.png'
Binary files www/media/images/svn/conflicted.png and www/media/images/svn/conflicted.png differ
